#ifndef _GPIO_H_
#define _GPIO_H_

#define PIN_11       0
#define PIN_14       1
#define PIN_15       2
#define PIN_MISO     3
#define PIN_MOSI     4
#define PIN_SCK      5
#define PIN_SDA      6
#define PIN_SCL      7
#define PIN_PWM      8

#define DIR_IN   0
#define DIR_OUT  1

void set_pin_direction(int pin, int dir) {
 static int directions = 0;
 
 if(dir == 0) directions &=~(1 << pin); else directions |= (1 << pin);
 
 FILE* f = fopen("/proc/gpio_dir", "rb+");
 if(f == NULL) return;
 
 rewind(f);
 fputc(directions & 0xff, f);
 fputc((directions >> 8) & 0xff, f);
 fclose(f);
}

void set_pin(int pin, int value) {
 static int pins = 0;
 
 if(value == 0) pins &=~(1 << pin); else pins |= (1 << pin);
 
 FILE* f = fopen("/proc/gpio_out", "rb+");
 if(f == NULL) return;
 
 rewind(f);
 fputc(pins & 0xff, f);
 fputc((pins >> 8) & 0xff, f);
 fclose(f);
}

int get_pin(int pin) {
 int val;
  
 FILE* f = fopen("/proc/gpio_in", "rb+");
 if(f == NULL) return 0;
 
 rewind(f);
 val = fgetc(f);
 val += (fgetc(f) << 8);
 fclose(f);
 
 return ((val & (1 << pin)) > 0);
}

int is_gpio_loaded() {
 FILE* f;
 f = fopen("/proc/gpio_dir", "rb+");
 if(f == NULL) return 0;
 fclose(f);
 f = fopen("/proc/gpio_in", "rb+");
 if(f == NULL) return 0;
 fclose(f);
 f = fopen("/proc/gpio_out", "rb+");
 if(f == NULL) return 0;
 fclose(f);
 return 1;
}

 
#endif
